'GSDIG  - PROGRAM TO DIGITIZE SAMPLE LOCATIONS
'
OPTION BASE 1
DEFDBL A-Z
	DIM SHARED DBWLL(5,2),DBWXY(5,2),SCW(4,2),DGW(4,2), _
		BUF(5),LATFAC(4),LONFAC(4), _
		DIGITIZER$,FILNAM$, _
		XMIN,XMAX,YMIN,YMAX,XWMIN,XWMAX,YWMIN,YWMAX,IDISP$, _
		ICH$,DSTRING$,KCOL%,ND%,PREFIX$,SUFFIX$,  _
		X0R,Y0R,SFX,SFY,XBOARD,YBOARD,SINCETA,COSCETA, _
		DGR,ECODE%,PTYP%,JOB%,LMASK%,FMT$,FMT%, _
		IQUAD%,CSCR$,TDISP$,DELTA(4,2), _
		TD%,SCRH%,SCRV%,ASPRAT!,MAPTYP$(5)
	DIM SHARED ICHR$(16),OCHR$(16),CPOS%,CWID%,XPOS%,XWID%,YPOS%,YWID%,XUNIT!,YUNIT!,DIGKEY%
	DIM SHARED F1,F2,F3,F4,S1S
	KEY OFF
	DEF FNRAS(XT,XSHIFT!)=XT*1016!+50!-XSHIFT!
	DEF FNMIN(A,B)=-B*(B<A)-A*(A<B)-A*(A=B)
	DEF FNMAX(A,B)=-B*(B>A)-A*(A>B)-A*(A=B)
	DEF FNPLT(XMAX,XMIN,MSCALE,ZOFF)=(((XMAX-XMIN)*39370.1)/MSCALE)+ZOFF
	DEF FNUpperCase$(AsciiString$)
		LenOfStr = len(AsciiString$)
		if (LenOfStr = 0) then FNUpperCase$ = "" : exit def
		for IJK=1 to LenOfStr
			AsciiValue=ASC(MID$(AsciiString$,IJK,1))
			if ((AsciiValue >= 97) and (AsciiValue <= 122)) then _
				AsciiValue=AsciiValue-32: _
				MID$(AsciiString$,IJK,1)=CHR$(AsciiValue)
		next IJK
		FNUpperCase$=AsciiString$
	END DEF
' DEFINE VARIABLES
	MAPTYP$(1)="  24,000   7 1/2 MINUTE"
	MAPTYP$(2)="  62,500   15 MINUTE"
	MAPTYP$(3)=" 100,000   30 MIN LAT x 1 DEG LONG"
	MAPTYP$(4)=" 250,000   1 DEG LAT x 2 DEG LONG"
	MAPTYP$(5)=" OTHER"
	LATFAC(1)=1#:LATFAC(2)=1#:LATFAC(3)=-1#:LATFAC(4)=-1#
	LONFAC(1)=-1#:LONFAC(2)=1#:LONFAC(3)=1#:LONFAC(4)=-1#
	DELTA(1,1)=.125
	DELTA(1,2)=.125
	DELTA(2,1)=.25
	DELTA(2,2)=.25
	DELTA(3,1)=.5
	DELTA(3,2)=1.0
	DELTA(4,1)=1.0
	DELTA(4,2)=2.0
	F1=0#:F2=0#:F3=0#:F4=0#:S1S=0.00000484136111#
	DGR=.0174532925199433#
	S$=""
	ICH$=SPACE$(1)
	DSTRING$=SPACE$(13)
	BUF(1)=6378.2064#
	BUF(2)=6356.5838#
	BUF(4)=0.9996#
	IQUAD%=1
	PTYP%=3
	ORIENT$="Y"
	IFO$="N"
	CSCR$=SPACE$(78)
	IDUM$=" ":IANS$=" "
	TITLE$="                "
'
' PRINT DISCLAIMER
'
	SCREEN 0:COLOR 15,1:WIDTH 80
	CLS
156	LOCATE  4,29:PRINT "   G  S  D  I  G"
	LOCATE  6,29:PRINT "    Version 1.00      "
	LOCATE 10,23:PRINT "           Gary I. Selner           "
	LOCATE 11,29:PRINT "U. S. Geological Survey"
	LOCATE 14,29:PRINT "     DISCLAIMER          "
	LOCATE 16,10:PRINT "Although program tests have been made, no guarantee (expressed";
	LOCATE 17,10:PRINT "or implied) is made by the author regarding program correctness,";
	LOCATE 18,10:PRINT "accuracy, or proper execution on all computer systems.";
	LOCATE 25,1:PRINT "HIT ANY KEY TO CONTINUE";
	LOCATE 25,50:IDUM$=INPUT$(1)
	CALL SetupDigitizer
	CALL SetupScreen
	GOTO MP
'trap routine for I/O error
2600	LOCATE 25,1
	BEEP
	BEEP
	INPUT "DEVICE ERROR - HIT ENTER TO RETRY",IDUM$
	ECODE%=1
	RESUME NEXT
' ERROR ROUTINE FOR OPEN OF CONFIG.SCR FILE
7400	ECODE%=1
	PRINT "AN ERROR HAS OCCURRED OPENING SCREEN CONFIGURATION FILE"
	PRINT "(CONFIG.SCR)"
	RESUME NEXT
' ERROR ROUTINE FOR OPEN OF CONFIG.DIG FILE
7403	ECODE%=1
	PRINT "AN ERROR HAS OCCURRED OPENING DIGITIZER CONFIGURATION FILE"
	PRINT "(CONFIG.DIG)"
	RESUME NEXT
'ERROR TRAP ON OPENING DIGITIZER
8260	IF ERR<>57 THEN
		CLS
		PRINT "UNKNOWN ERROR OPENING DIGITIZER. BASIC CODE= ";ERR
		PRINT "HIT ANY KEY TO RETRY"
		IDUM$=INPUT$(1)
	ELSE
		CLS
		PRINT "DEVICE I/O ERROR OPENING DIGITIZER - RETRYING"
	END IF
	ECODE%=1
	RESUME NEXT
'ERROR ROUTINE FOR OPENING PROJECTION PARAMETERS FILE
8750	PRINT "AN ERROR HAS OCCURRED OPENING PROJECTION PARAMETERS FILE"
	PRINT "RETURNING TO ALLOW RE-ENTRY."
	ECODE%=1
	RESUME NEXT
'ERROR ROUTINE FOR OPENING THE OUTPUT FLE
8760	ECODE%=1
	RESUME NEXT
MP:	CLS
	LOCATE 1,1
	PRINT "THERE ARE TWO OUTPUT FORMATS AVAILABLE:
	PRINT
	PRINT "1 - GENERIC"
	PRINT "2 - LOTUS STYLE FORMAT"
	PRINT
	INPUT "ENTER DESIRED FORMAT(1,2): ",FMT%
	PRINT
	INPUT "ENTER OUTPUT FILE NAME: ",FILNAM$
	ECODE%=0
	ON ERROR GOTO 8760
	OPEN FILNAM$ FOR INPUT AS #2
	ON ERROR GOTO 0
	CLOSE #2
	IF ECODE%=1 THEN
		OPEN FILNAM$ FOR OUTPUT AS #2
	ELSE
		PRINT "A FILE OF THE SAME NAME ALREADY EXISTS"
		INPUT "DO YOU WANT TO APPEND TO IT?(Y/N): ",IANS$
		IANS$=FNUpperCase$(IANS$)
		IF IANS$="N" THEN
			OPEN FILNAM$ FOR OUTPUT AS #2
		ELSE
			OPEN FILNAM$ FOR APPEND AS #2
		END IF
	END IF
	PRINT
	PRINT "FOLLOWING QUESTIONS APPLY TO SAMPLE ID MASK:"
	INPUT "ENTER PREFIX: ",PREFIX$
	INPUT "MAXIMUM NO. OF DIGITS: ",ND%
	INPUT "ENTER SUFFIX: ",SUFFIX$
	LMASK%=LEN(PREFIX$)+ND%+LEN(SUFFIX$)
ML:	CLS
	SCREEN 0:COLOR 15,1:WIDTH 80
	LOCATE 1,1
	PRINT "ENTER MAP NAME(QUIT TO EXIT):"
	INPUT MAP$ 
	UCMAP$=FNUpperCase$(MAP$)
	IF UCMAP$<>"QUIT" THEN
		INPUT "DO YOU WANT TO CHANGE SAMPLE ID MASK(Y/N): ",IANS$
		IANS$=FNUpperCase$(IANS$)
		IF IANS$="Y" THEN
			PRINT "FOLLOWING QUESTIONS APPLY TO SAMPLE ID MASK:"
			INPUT "ENTER PREFIX: ",PREFIX$
			INPUT "MAXIMUM NO. OF DIGITS: ",ND%
			INPUT "ENTER SUFFIX: ",SUFFIX$
			LMASK%=LEN(PREFIX$)+ND%+LEN(SUFFIX$)
		END IF
		IF FMT%=2 THEN
			PRINT #2,CHR$(34)+MAP$+CHR$(34)
		END IF
MT:		CLS
		LOCATE 1,1
		PRINT "TYPES OF MAPS"
		PRINT
		FOR I% = 1 TO 5
			PRINT STR$(I%)+" - "+MAPTYP$(I%)
		NEXT I%
		PRINT
		INPUT "ENTER TYPE: ",TYPE%
		IF TYPE%<1 OR TYPE%>5 THEN
			LOCATE 25,1
			PRINT "INVALID TYPE OF MAP - HIT ANY KEY TO CONTINUE";
			IDUM$=INPUT$(1)
			GOTO MT
		END IF
SPIN:		PRINT "ENTER NORTHWEST CORNER OF AREA(DD,MM,SS,DDD,MM,SS):"
		INPUT LATD,LATM,LATS,LOND,LONM,LONS
		DBWLL(1,1)=LATFAC(IQUAD%)*(LATD+LATM/60.0D0+LATS/3600.0D0)
		DBWLL(1,2)=LONFAC(IQUAD%)*(LOND+LONM/60.0D0+LONS/3600.0D0)
		IF TYPE%>=1 AND TYPE%<=4 THEN
			M1=3600.0D0*ABS(DBWLL(1,1))
			M2=3600.0D0*ABS(DELTA(TYPE%,1))
			MLAT%=INT(M1/M2)
			MLAT=ABS(DBWLL(1,1))-MLAT%*DELTA(TYPE%,1)
			M1=3600.0D0*ABS(DBWLL(1,2))
			M2=3600.0D0*ABS(DELTA(TYPE%,2))
			MLON%=INT(M1/M2)
			MLON=ABS(DBWLL(1,2))-MLON%*DELTA(TYPE%,2)
			IF MLAT<>0 OR MLON<>0 THEN
				PRINT "INVALID COORDINATE FOR THIS TYPE OF MAP"
				PRINT "CHECK AND RE-ENTER"
				GOTO SPIN
			END IF
		END IF
		IF TYPE%>=1 AND TYPE%<=4 THEN
				DBWLL(2,1)=DBWLL(1,1)-(LATFAC(IQUAD%)*DELTA(TYPE%,1))
				DBWLL(2,2)=DBWLL(1,2)
				DBWLL(3,1)=DBWLL(2,1)
				DBWLL(3,2)=DBWLL(1,2)-(LONFAC(IQUAD%)*DELTA(TYPE%,2))
				DBWLL(4,1)=DBWLL(1,1)
				DBWLL(4,2)=DBWLL(3,2)
				IF FMT%=2 THEN
					PRINT #2,CHR$(34)+MAPTYP$(TYPE%)+CHR$(34)
				END IF
		ELSEIF TYPE%= 5 THEN
			PRINT "ENTER SOUTHWEST CORNER OF AREA(DD,MM,SS,DDD,MM,SS):"
			INPUT LATD,LATM,LATS,LOND,LONM,LONS
			DBWLL(2,1)=LATFAC(IQUAD%)*(LATD+LATM/60.0D0+LATS/3600.0D0)
			DBWLL(2,2)=LONFAC(IQUAD%)*(LOND+LONM/60.0D0+LONS/3600.0D0)
			PRINT "ENTER SOUTHEAST CORNER OF AREA(DD,MM,SS,DDD,MM,SS):"
			INPUT LATD,LATM,LATS,LOND,LONM,LONS
			DBWLL(3,1)=LATFAC(IQUAD%)*(LATD+LATM/60.0D0+LATS/3600.0D0)
			DBWLL(3,2)=LONFAC(IQUAD%)*(LOND+LONM/60.0D0+LONS/3600.0D0)
			PRINT "ENTER NORTHEAST CORNER OF AREA(DD,MM,SS,DDD,MM,SS):"
			INPUT LATD,LATM,LATS,LOND,LONM,LONS
			DBWLL(4,1)=LATFAC(IQUAD%)*(LATD+LATM/60.0D0+LATS/3600.0D0)
			DBWLL(4,2)=LONFAC(IQUAD%)*(LOND+LONM/60.0D0+LONS/3600.0D0)
			CALL SetupProjection
			MINLAT=1.0E23
			FOR I%=1 TO 4
				MINLAT=FNMIN(MINLAT,DBWLL(I%,1))
			NEXT I%
			DBWLL(5,1)=MINLAT
			IF FMT%=2 THEN
				PRINT #2,CHR$(34)+MAPTYP$(TYPE%)+CHR$(34)
			END IF
		END IF
		IF TYPE%>=1 AND TYPE%<=4 THEN
			IZONE%=FIX(ABS((DBWLL(2,2)+DBWLL(3,2))/2))
			IZONE%=FIX(IZONE%/6)
			CM=LONFAC(IQUAD%)*(IZONE%*6D0+3D0)
			BUF(3)=CM
			DBWLL(5,1)=DBWLL(2,1)
			DBWLL(5,2)=CM
		END IF
		IF FMT%=2 THEN
			CALL CONDMS(DBWLL(1,1),S1$)
			CALL CONDMS(DBWLL(1,2),S2$)
			CALL CONDMS(DBWLL(3,1),S3$)
			CALL CONDMS(DBWLL(3,2),S4$)
			PRINT #2,CHR$(34)+S1$+S2$+S3$+S4$+CHR$(34)
		END IF
		JOB%=1
		LATD=91.0D0
		LOND=CM
		CALL LTLNXY(LATD,LOND,XN,YE,PTYP%,JOB%,BUF())
		JOB%=2
		FOR I%=1 TO 5
			LATD=DBWLL(I%,1)
			LOND=DBWLL(I%,2)
			CALL LTLNXY(LATD,LOND,XN,YE,PTYP%,JOB%,BUF())
			DBWXY(I%,1)=YE
			DBWXY(I%,2)=XN
		NEXT I%
		JOB%=1
		XN=0#:YE=0#
		CALL XYLTLN(XN,YE,LATD,LOND,PTYP%,JOB%,BUF())
		JOB%=2
		XMIN=1.0E23
		XMAX=-1.0E23
		YMIN=1.0E23
		YMAX=-1.0E23
		FOR I%=1 TO 4
			XMIN=FNMIN(XMIN,DBWXY(I%,1))
			XMAX=FNMAX(XMAX,DBWXY(I%,1))
			YMIN=FNMIN(YMIN,DBWXY(I%,2))
			YMAX=FNMAX(YMAX,DBWXY(I%,2))
		NEXT I%
		IF XMIN<=DBWXY(5,1) AND XMAX>=DBWXY(5,1) THEN
			YMIN=FNMIN(YMIN,DBWXY(5,2))
			YMAX=FNMAX(YMAX,DBWXY(5,2))
		END IF
		SCW(1,1)=XMIN
		SCW(1,2)=YMIN
		SCW(2,1)=XMAX
		SCW(2,2)=YMAX
		CALL DigitizeSampleLocations
		IF FMT%=2 THEN
			PRINT #2,CHR$(34)+"*"+CHR$(34)
		END IF
		GOTO ML
	END IF
	CLOSE #2
END
SUB CONDMS(DECDEG#,S$) STATIC
'
'SUBROUTINE TO CONVERT DOUBLE PRECISION DECIMAL DEGREES TO 
'13 CHARACTER STRING FOR PRINTING
'
	INTDEG%=FIX(ABS(DECDEG#))
	TEMP#=ABS(DECDEG#)-CDBL(INTDEG%)
	INTMIN%=FIX(TEMP#*60#)
	TEMP#=TEMP#*60#-CDBL(INTMIN%)
	SNGSEC!=CSNG(TEMP#*60#)
	IF SNGSEC! < .0001 THEN SNGSEC! = 0.0
	IF SNGSEC! >= 60! THEN INTMIN% = INTMIN% + 1: SNGSEC! = SNGSEC! -60
	IF INTMIN% >= 60  THEN INTDEG% = INTDEG% + 1: INTMIN% = INTMIN% - 60
	S$=SPACE$(13)
	TEMP$=MID$(STR$(INTDEG%),2,3):MID$(S$,1,3)=TEMP$
	TEMP$=MID$(STR$(INTMIN%),2,2):MID$(S$,5,2)=TEMP$
	TEMP$=MID$(STR$(SNGSEC!),2,6):MID$(S$,8,6)=TEMP$
END SUB
SUB CONDMFS(DECDEG#,LATD%,LATM%,LATS!) STATIC
'
'SUBROUTINE TO CONVERT DOUBLE PRECISION DECIMAL DEGREES TO 
'INTEGER DEGREES, INTEGER MINUTES, FLOATING SECONDS
'
	LATD%=FIX(ABS(DECDEG#))
	TEMP#=ABS(DECDEG#)-CDBL(LATD%)
	LATM%=FIX(TEMP#*60#)
	TEMP#=TEMP#*60#-CDBL(LATM%)
	LATS!=TEMP#*60#
	IF LATS! < .0001 THEN LATS! = 0.0
	IF LATS! >= 60! THEN LATM% = LATM% + 1: LATS! = LATS! -60
	IF LATM% >= 60  THEN LATD% = LATD% + 1: LATM% = LATM% - 60
END SUB
	SUB DigitizeSampleLocations STATIC
'ROUTINE TO DIGITIZE NEW ENTRIES
		CLS
		IF FMT%=2 THEN
			FMT$="!"+"!"+"!"+" !\"+SPACE$(LMASK%-2)+"\!  \           \   \            \"
		ELSE
			FMT$="\"+SPACE$(LMASK%-2)+"\## ## ##.###!### ## ##.###!"
		END IF
'open up the digitizer
1690		ECODE%=0
		ON ERROR GOTO 8260                 'TRAP ROUTINE
		OPEN DIGITIZER$ AS #1
		ON ERROR GOTO 0
		IF ECODE%=1 GOTO 1690
1691		PRINT "ENTER 0(ZERO) KEY ON CURSOR KEYPAD TO SYNCHRONIZE DIGITIZER INPUT"
		CALL GetDigitizer
		BEEP
		IF ICH$<>"0" GOTO 1691 
		PRINT "ENTER NORTHWEST CORNER ON DIGITIZER"
		CALL GetDigitizer
		DGW(1,1)=XBOARD
		DGW(1,2)=YBOARD
		BEEP
		PRINT "ENTER SOUTHWEST CORNER ON DIGITIZER"
		CALL GetDigitizer
		DGW(2,1)=XBOARD
		DGW(2,2)=YBOARD
		BEEP
		PRINT "ENTER SOUTHEAST CORNER OF DIGITIZER"
		CALL GetDigitizer
		DGW(3,1)=XBOARD
		DGW(3,2)=YBOARD
		BEEP
		PRINT "ENTER NORTHEAST CORNER ON DIGITIZER"
		CALL GetDigitizer
		DGW(4,1)=XBOARD
		DGW(4,2)=YBOARD
		BEEP
		XT=DGW(1,1)-DGW(2,1)
		YT=DGW(1,2)-DGW(2,2)
		IF XT=0# THEN
			BETA=1.570796327#
		ELSE
			BETA=ATN(YT/XT)
		END IF
		XT=DBWXY(1,1)-DBWXY(2,1)
		YT=DBWXY(1,2)-DBWXY(2,2)
		IF XT=0# THEN
			ALPHA=1.570796327#
		ELSE
			ALPHA=ATN(YT/XT)
		END IF
		CETA=BETA-ALPHA
		SINCETA=SIN(CETA)
		COSCETA=COS(CETA)
		XN=(DGW(3,1)-DGW(2,1))*COSCETA+(DGW(3,2)-DGW(2,2))*SINCETA
		YN=(DGW(1,2)-DGW(2,2))*COSCETA-(DGW(1,1)-DGW(2,1))*SINCETA
		SFX=(DBWXY(3,1)-DBWXY(2,1))/XN
		SFY=(DBWXY(1,2)-DBWXY(2,2))/YN
		DIFFPCT=(ABS(SFX-SFY)/SFX)*100!
		IF DIFFPCT>2 THEN
			BEEP
			BEEP
			PRINT "SCALE DIFFERS BY MORE THAN 2 % IN X AND Y."
		END IF
		XT!=ABS(39370.1#*SFX)
		YT!=ABS(39370.1#*SFY)
		PRINT
		PRINT USING "X SCALE= ###########,.   Y SCALE= ###########,.";XT!,YT!
		PRINT
		INPUT "CONTINUE? (Y/N) ",IANS$
		IANS$=FNUpperCase$(IANS$)
		IF IANS$="N" GOTO 2570
		CLS
		SCREEN TD%
		IF (SCW(2,1)-SCW(1,1)) > ASPRAT!*(SCW(2,2)-SCW(1,2)) THEN
			SSX!=SCRH%/(SCW(2,1)-SCW(1,1))
			SSY!=SSX!*(1.0/ASPRAT!)
		ELSE
			SSY!=SCRV%/(SCW(2,2)-SCW(1,2))
			SSX!=SSY!*ASPRAT!
		END IF
		SCRX%=FIX((SCW(2,1)-SCW(1,1))*SSX!)
		SCRY%=FIX((SCW(2,2)-SCW(1,2))*SSY!)
		IF SCRX%>SCRH% THEN SCRX%=SCRH%
		IF SCRY%>SCRV% THEN SCRY%=SCRV%
		CX%=FIX((SCRH%-SCRX%)/2)
		CY%=FIX((SCRV%-SCRY%)/2)
		VIEW (CX%,CY%)-(SCRX%+CX%,SCRY%+CY%)
		WINDOW (SCW(1,1),SCW(1,2))-(SCW(2,1),SCW(2,2))
		LINE (SCW(1,1),SCW(1,2))-(SCW(2,1),SCW(2,2)),KCOL%,B
		X0R=DGW(2,1)
		Y0R=DGW(2,2)
2010		SOUND 1760,9.100001
		CALL GetParameterFromDigitizer(ND%,SAMP!,PUNT$)
		IF PUNT$="Y" GOTO 2010
		IF SAMP!=0 GOTO 2570
		LOCATE 25,1
		TEMP$=STR$(SAMP!)
		SAMP$=SPACE$(ND%+1)
		RSET SAMP$=TEMP$
		FOR I%=1 TO ND%+1
			IF MID$(SAMP$,I%,1)=" " THEN
				MID$(SAMP$,I%,1)="0"
			END IF 
		NEXT I%
		SAMP$=PREFIX$+MID$(SAMP$,2,ND%)+SUFFIX$
		PRINT "SAMPLE= ";SAMP$;
2170		CALL GetDigitizer
		SOUND 196,2
		IF ICH$="E" GOTO 2010
		IF ICH$ = "1" THEN
			XD=XBOARD-X0R
			YD=YBOARD-Y0R
		ELSE
			SOUND 130.810,6.5
			GOTO 2170
		END IF
		XT=XD*COSCETA+YD*SINCETA
		YT=YD*COSCETA-XD*SINCETA
		UXP=DBWXY(2,1)+SFX*XT
		UYP=DBWXY(2,2)+SFY*YT
'compute latitude-longitude from xy of current projection
		CALL XYLTLN(UYP,UXP,LATP,LONP,PTYP%,JOB%,BUF())
		IF (FMT%=2) THEN
			CALL CONDMS(LATP,S1$)
			CALL CONDMS(LONP,S2$)
			PRINT #2,USING FMT$;CHR$(34),"*",CHR$(34),CHR$(34),SAMP$,CHR$(34),S1$,S2$
		ELSE
			CALL CONDMFS(LATP,LATD%,LATM%,LATS!)
			CALL CONDMFS(LONP,LOND%,LONM%,LONS!)
			PRINT #2,USING FMT$;SAMP$,LATD%,LATM%,LATS!,"N",LOND%,LONM%,LONS!,"W"
		END IF
		UXS!=UXP:UYS!=UYP
		CALL DrawSymbol(UXS!,UYS!)
		CLOSE #2
		OPEN FILNAM$ FOR APPEND AS #2
		GOTO 2010
'all done close digitizer
2570	CLOSE #1
	END SUB
	SUB GetDigitizer STATIC
'subroutine to interface to digitizer board
'actual interface routine
		ON ERROR GOTO 2600
2061		ECODE%=0
		LINE INPUT #1,DSTRING$
		IF ECODE%=1 GOTO 2061
		ON ERROR GOTO 0
		FOR IJK%=1 TO DIGKEY%
			IF MID$(DSTRING$,CPOS%,1)=ICHR$(IJK%) THEN
				MID$(DSTRING$,CPOS%,1)=OCHR$(IJK%)
			END IF
		NEXT IJK%
		ICH$=MID$(DSTRING$,CPOS%,CWID%)
		XBOARD=XUNIT!*VAL(MID$(DSTRING$,XPOS%,XWID%))
		YBOARD=YUNIT!*VAL(MID$(DSTRING$,YPOS%,YWID%))
	END SUB
	SUB GetParameterFromDigitizer(ND%,SAMP!,PUNT$) STATIC 
'routine to get lcode, para1 or para2
		SAMP!=0
		PUNT$="N"
		FOR J%=1 TO ND%
			CALL GetDigitizer
			IF ICH$="E" THEN
				PUNT$="Y"
				GOTO GPFD1
			ELSEIF ICH$="A" THEN
				GOTO GPFD
			ELSEIF ICH$="B" THEN
				CSCR$=SPACE$(78)
				LOCATE 25,1
				PRINT CSCR$;
				LOCATE 25,1
				INPUT; "ENTER PREFIX: ",PREFIX$
				LOCATE 25,1
				PRINT CSCR$;
				LOCATE 25,1
				INPUT; "MAXIMUM NO. OF DIGITS: ",ND%
				LOCATE 25,1
				PRINT CSCR$;
				LOCATE 25,1
				INPUT; "ENTER SUFFIX: ",SUFFIX$
				LOCATE 25,1
				PRINT CSCR$;
				PUNT$="Y"
				LMASK%=LEN(PREFIX$)+ND%+LEN(SUFFIX$)
				IF FMT%=2 THEN
					FMT$="!"+"!"+"!"+" !\"+SPACE$(LMASK%-2)+"\!  \           \   \            \"
				ELSE
					FMT$="\"+SPACE$(LMASK%-2)+"\## ## ##.###!### ## ##.###!"
				END IF
				GOTO GPFD1
			ELSE
				SAMP!=SAMP!*10 + VAL(ICH$)
			END IF
		NEXT J%
GPFD:		SOUND 261,6.5
GPFD1:
	END SUB
	SUB DrawSymbol(UXS!,UYS!) STATIC
		PSET (UXS!,UYS!),KCOL%
	END SUB
	SUB SetupProjection STATIC
'SETUP PROJECTION PARAMETERS
		CLS
PROJ11:		ECODE%=0
		INPUT "ENTER FILENAME OF PROJECTION PARAMETERS: ",SFILNAM$
		ON ERROR GOTO 8750
		OPEN SFILNAM$ FOR INPUT AS #5
		ON ERROR GOTO 0
		IF ECODE%=1 GOTO PROJ11
		INPUT #5,IQUAD%
		INPUT #5,PTYP%
		INPUT #5,BUF(1)
		INPUT #5,BUF(2)
		IF PTYP% = 1 THEN
			INPUT #5,BUF(3)
			INPUT #5,LOND,LONM,LONS
			CM=LONFAC(IQUAD%)*(LOND+LONM/60.0#+LONS/3600.0#)
			BUF(4)=CM
			DBWLL(5,2)=CM
		ELSEIF PTYP% = 2 THEN
			INPUT #5,BUF(3),BUF(4)
			INPUT #5,LOND,LONM,LONS
			CM=LONFAC(IQUAD%)*(LOND+LONM/60.0#+LONS/3600.0#)
			BUF(5)=CM
			DBWLL(5,2)=CM
		ELSEIF PTYP% = 3 THEN
			INPUT #5,LOND,LONM,LONS
			CM=LONFAC(IQUAD%)*(LOND+LONM/60.0#+LONS/3600.0#)
			BUF(3)=CM
			INPUT#5,BUF(4)
			DBWLL(5,2)=CM
		ELSEIF PTYP% = 4 THEN
			INPUT #5,BUF(3),BUF(4)
			INPUT #5,LOND,LONM,LONS
			CM=LONFAC(IQUAD%)*(LOND+LONM/60.0#+LONS/3600.0#)
			BUF(5)=CM
			DBWLL(5,2)=CM
		ELSEIF PTYP% = 5 THEN
			BUF(3)=0.0#
			BUF(4)=0.0#
			CM=0.0#
			DBWLL(5,2)=CM
		ELSE
			PRINT "INVALID PROJECTION TYPE"
			RETURN
		END IF
'SET UP PROJECTION SUBROUTINES
		CLOSE #5
	END SUB
SUB SetupDigitizer STATIC
	ECODE%=0
	ON ERROR GOTO 7403
	OPEN "CONFIG.DIG" FOR INPUT AS #1
	ON ERROR GOTO 0
	IF ECODE%=1 GOTO SUD
	INPUT #1,DIGITIZER$
	INPUT #1,CPOS%,CWID%
	INPUT #1,XPOS%,XWID%,XUNIT!
	INPUT #1,YPOS%,YWID%,YUNIT!
	INPUT #1,DIGKEY%
	FOR I%=1 TO DIGKEY%
		INPUT #1,ICHR$(I%),OCHR$(I%)
	NEXT I%
	CLOSE #1
SUD:	END SUB
SUB SetupScreen STATIC
'
' Subroutine to select screen colors for EGA with color monitor
'
	ON ERROR GOTO 7400
	OPEN "CONFIG.SCR" FOR INPUT AS #1
	ON ERROR GOTO 0
	IF ECODE%=1 GOTO SUS
	INPUT #1,TDISP$
	TDISP$=FNUpperCase$(TDISP$)
	IF TDISP$ = "CGAC" THEN
		TD% = 2
		SCRH% = 639
		SCRV% = 190
		ASPRAT!=480/200
		KCOL%=1
	ELSEIF TDISP$ = "CGAM" THEN
		TD% = 2
		SCRH% = 639
		SCRV% = 190
		ASPRAT!=480/200
		KCOL%=1
	ELSEIF TDISP$ = "EGAM" THEN
		TD% = 10
		SCRH% = 639
		SCRV% = 330
		ASPRAT!=480/350
		KCOL%=1
	' FOLLOWING ASSUMES TDISP$ = "EGAC"
	ELSEIF TDISP$ = "EGAC" THEN
		TD%=9
		SCRH% = 639
		SCRV%=330
		ASPRAT!=480/350
		KCOL%=14
	ELSE
		TD% = 2
		SCRH% = 639
		SCRV% = 190
		ASPRAT!=480/200
		KCOL%=1
	END IF
	CLOSE #1
SUS:	END SUB
	 SUB LTLNXY(LAT,LON,XN,YE,PTYP%,JOB%,BUF(1)) STATIC
'SUBROUTINE FOR COMPUTING NORTHING AND EASTING OF LATITUDE-LONGITUDE POINT
'MAP PROJECTION AND XY TRANSFORMATION ROUTINE
'MODIFIED FROM UNIV. OREGON ROUTINE BY MEG.
'GETTINGS,USGS,FEB 1979.
'
'PARAMETERS (ALL REAL*8 EXCEPT PTYP%,JOB%)
'        LAT-LATITUDE IN DEG & DEC.PARTS
'        LON-LONGITUDE IN DEG & DEC.PARTS
'        FOR JOB%=1, LAT,LON ARE LOCATION OF ARBITRARY ORIGIN
'        IF ABS(LAT)>90.0,ORIGIN IS ORIGIN OF PROJECTION.
'        XN-NORTH COORDINATE,KM.
'        YE-EAST COORDINATE,KM.
'        PTYP%-PROJECTION TYPE (INTEGER)
'            =1 LAMBERT CONFORMAL CONIC 1 PARALLEL
'            =2 LAMBERT CONFORMAL CONIC 2 PARALLELS
'            =3 UNIVERSAL TRANSVERSE MERCATOR
'            =4 ALBERS EQUAL AREA
'	     =5 MERCATOR
'        JOB%-1 SET UP PARAMETERS & CONSTANTS
'           -2 TRANSFORM A POINT
'        BUF(1)-BUF(5)- BUFFER CONTAINING PARAMETERS
'                       FOR JOB% = 1.
'
      STATIC XORO,YORO,PHI0,LAM0,EC,R0,SP0,C,PHI1,PHI2,EP2,X,SCF, _
             C11,C12,C13,C14,C21,C22,AEQ,ALF,A11,A12,A21,A22
      STATIC A,B,ECS,NS,M1
      DGR=1.74532925199433D-2
      IF(JOB%=2) GOTO L500
      XORO=0.0D0
      YORO=0.0D0
      ON PTYP% GOTO L10,L20,L30,L40,L50
'
'LAMBERT CONF. CONIC 1 PARALLEL
'BUF(1)=EQ. RADIUS SPHEROID,KM.
'BUF(2)=POLAR RAD. SPHEROID,KM.
'BUF(3)=LAT. STANDARD PARALLEL,DEG.
'BUF(4)=LONG. CENTRAL MERIDIAN,DEG.
'
L10:  PHI0=BUF(3)*DGR
      LAM0=BUF(4)*DGR
	BUF1=BUF(1): BUF2=BUF(2)
	CALL SUBE(BUF1,BUF2,EC)
      CALL SUBNPHI(BUF1,EC,PHI0/TAN(PHI0),RESULT)
      R0=RESULT
      SP0=SIN(PHI0)
      CALL SUBTERM(PHI0,EC,SP0,RESULT)
      C=R0/RESULT
      IF(ABS(LAT)>90.0D0) GOTO L900
      GOTO L110
'
'LAMBERT COMFORMAL CONIC 2 PARALLELS
'BUF(1)=EQ. RADIUS SPHEROID
'BUF(2)=POLAR RAD. SPHEROID
'BUF(3)=LAT. STAND. PARALLEL 1,DEG (PAR. FURTHEST FR. EQ.)
'BUF(4)=LAT. STAND. PARALLEL 2,DEG.
'BUF(5)=LON. CENTRAL MERIDIAN,DEG.
'
L20:  LAM0=BUF(5)*DGR
      PHI1=BUF(3)*DGR
      PHI2=BUF(4)*DGR
 	BUF1=BUF(1): BUF2=BUF(2)
	CALL SUBE(BUF1,BUF2,EC)
      CALL SUBNPHI(BUF1,EC,PHI1,RESULT1):CALL SUBNPHI(BUF(1),EC,PHI2,RESULT2)
      SP0=LOG(RESULT1*COS(PHI1))-LOG(RESULT2*COS(PHI2))
      CALL SUBTERM(PHI1,EC,1.0D0,RESULT1):CALL SUBTERM(PHI2,EC,1.0D0,RESULT2)
      SP0=SP0/(LOG(RESULT1)-LOG(RESULT2))
      PHI0=ATN(SP0/SQR(1.0D0-SP0*SP0))
      CALL SUBNPHI(BUF1,EC,PHI1,RESULT)
      CALL SUBTERM(PHI1,EC,SP0,RESULT2)
      C=(RESULT*COS(PHI1))/(SP0*RESULT2)
      CALL SUBTERM(PHI0,EC,SP0,RESULT)
      R0=C*RESULT
      IF(ABS(LAT)>90.0D0) GOTO L900
      GOTO L110
'
'UNIVERSAL TRANSVERSE MERCATOR
'BUF(1)=EQ. RADIUS SPHEROID,KM.
'BUF(2)=POLAR RAD. SPHEROID,KM.
'BUF(3)=LON. CENTRAL MERIDIAN,DEG.
'BUF(4)=SCALE FACTOR M0 (USUALLY 0.9996)
'
L30:	BUF1=BUF(1):BUF2=BUF(2)
	CALL SUBE(BUF1,BUF2,EC)
      EP2=EC*EC
      CALL SUBSPHI(0.0D0,BUF1,BUF2,1,X)
      SCF=BUF(4)
      LAM0=BUF(3)*DGR
      C11=9.D0*EP2
      C12=4.D0*EP2
      C13=270.D0*EP2
      C14=330.D0*EP2
      C21=14.D0*EP2
      C22=58.D0*EP2
      AEQ=BUF(1)
      IF(ABS(LAT)>90.D0)GOTO L900
      GOTO L130
'
' ALBERS EQUAL AREA
'BUF(1)=EQ. RADIUS SPHEROID
'BUF(2)=POLAR RAD. SPHEROID
'BUF(3)=LAT. STAND. PARALLEL 1,DEG (PAR. FURTHEST FR. EQ.)
'BUF(4)=LAT. STAND. PARALLEL 2,DEG.
'BUF(5)=CENTRAL MERIDIAN, DEG.
'
L40:    LAM0=BUF(5)*DGR
	PHI1=BUF(3)*DGR
	PHI2=BUF(4)*DGR
 	BUF1=BUF(1): BUF2=BUF(2)
	CALL SUBE(BUF1,BUF2,EC)
	CALL SUBNPHI(BUF1,EC,PHI1,RESULT1):CALL SUBNPHI(BUF(1),EC,PHI2,RESULT2)
	SP0=LOG(RESULT1*COS(PHI1))-LOG(RESULT2*COS(PHI2))
	CALL SUBTERM(PHI1,EC,1.0D0,RESULT1):CALL SUBTERM(PHI2,EC,1.0D0,RESULT2)
	SP0=SP0/(LOG(RESULT1)-LOG(RESULT2))
	PHI0=ATN(SP0/SQR(1.0D0-SP0*SP0))
	A=BUF(1):B=BUF(2):EC=SQR(1.0#-(B/A)^2):ECS=EC*EC
	SINPHI=SIN(PHI1):CON=SINPHI:COSPHI=COS(PHI1)
	CALL MSFNZ0(EC,SINPHI,COSPHI,MS1)
	CALL QSFNZ0(EC,SINPHI,COSPHI,QS1)
	SINPHI=SIN(PHI2):COSPHI=COS(PHI2)
	CALL MSFNZ0(EC,SINPHI,COSPHI,MS2)
	CALL QSFNZ0(EC,SINPHI,COSPHI,QS2)
	SINPHI=SIN(PHI0):COSPHI=COS(PHI0)
	CALL QSFNZ0(EC,SINPHI,COSPHI,QS0)
	NS=(MS1*MS1 - MS2*MS2)/(QS2-QS1)
	C=MS1*MS1 + NS*QS1
	R0=A*SQR(C-NS*QS0)/NS
	IF LAT>90.0 GOTO L900
	GOTO L140
' MERCATOR
'BUF(1)=EQ. RADIUS SPHEROID
'BUF(2)=POLAR RAD. SPHEROID
'BUF(3)=LATITUDE OF ORIGIN
'BUF(4)=LONGITUDE OF ORIGIN
'
L50: 	BUF1=BUF(1): BUF2=BUF(2)
	CALL SUBE(BUF1,BUF2,EC)
	PHI0=DGR*BUF(3)
	LAM0=DGR*BUF(4)
	M1=COS(PHI0)/SQR(1.0#-EC*SIN(PHI0)^2)
	IF LAT>90.0 GOTO L900
	GOTO L150
'
'TRANSFORM A POINT (JOB%=2)
'
L500: ON PTYP% GOTO L110,L110,L130,L140,L150
'
'LAMBERT CONFORMAL CONIC
'
L110: PHI=LAT*DGR
      LAM=LON*DGR
      DL=(LAM-LAM0)*SP0
      CALL SUBTERM(PHI,EC,SP0,RESULT)
      R=C*RESULT
      XN=R0-R*COS(DL)-XORO
      YE=R*SIN(DL)-YORO
      IF(JOB%=2) GOTO L900
      XORO=XN
      YORO=YE
      GOTO L900
'
'UNIVERSAL TRANSVERSE MERCATOR
'
L130: PHI=LAT*DGR
      LAM=LON*DGR
      DL=LAM-LAM0
      DL2=DL*DL
      SNP=SIN(PHI)
      CSP=COS(PHI)
      TNP=SNP/CSP
      SN2=SNP*SNP
      CS2=CSP*CSP
      TN2=TNP*TNP
      CALL SUBNPHI(AEQ,EC,PHI,RESULT)
      RN=RESULT*SCF
      XN=0.5D0+DL2/24.D0*CS2*(5.D0-TN2+C11*CS2+C12*CS2*CS2)
      XN=XN+DL2*DL2/720.D0*CS2*CS2*(61.D0-58.D0*TN2+TN2*TN2+C13*CS2- _
          C14*SN2)
      CALL SUBSPHI(PHI,D1,D2,2,RESULT)
      XN=XN*DL2*SNP*CSP*RN+SCF*RESULT
      YE=1.D0+DL2*CS2/6.D0*(1.D0-TN2+EP2*CS2)
      YE=YE+DL2*DL2*CS2*CS2/120.D0*(5.D0-18.D0*TN2+TN2*TN2+C21*CS2- _
          C22*SN2)
      YE=YE*RN*CSP*DL
      XN=XN-XORO
      YE=YE-YORO
      IF(JOB%=2) GOTO L900
      XORO=XN
      YORO=YE
      GOTO L900
'
' ALBERS EQUAL AREA
'
L140:	PHI=DGR*LAT
	LAM=DGR*LON
	SINPHI=SIN(PHI):COSPHI=COS(PHI)
	CALL QSFNZ0(EC,SINPHI,COSPHI,QS)
	RH=A*SQR(C-NS*QS)/NS
	THETA=NS*(LAM-LAM0)
	YE=RH*SIN(THETA)
	XN=R0 - RH*COS(THETA)
      IF(JOB%=2) GOTO L900
      XORO=XN
      YORO=YE
' MERCATOR 
L150:	PHI=DGR*LAT
	LAM=DGR*LON
	SINPHI = SIN(PHI)
	CALL TSFNZ0(EC,PHI,SINPHI,RESULT)
	TS=RESULT
	YE=BUF1*M1*LAM
	XN=-1#*(BUF1*M1*LOG(TS))
	IF (JOB%=2) GOTO L900
	XORO=XN
	YORO=YE
L900: END SUB
'FUNCTION FOR ECCENTRICITY
'
    SUB SUBE(A,B,RESULT) STATIC
      RESULT=SQR((A*A-B*B)/(A*A))
    END SUB
'FUNCTION DEFN FOR RAD. CURV. PRIME VERTICAL
'
    SUB SUBNPHI(A,E,PHI,RESULT) STATIC
      RESULT=A/SQR(1.0#-E*E*(SIN(PHI))^2)
    END SUB
'
'FUNCTION 
'
    SUB SUBTERM(PHI,E,SP0,RESULT) STATIC
      SNP=SIN(PHI)
      TEMP=((1.#+E*SNP)/(1.#-E*SNP))^(E/2.#)
      TEMP=TEMP*TAN(0.7853981635# -PHI/2.#)
      RESULT=TEMP^SP0
    END SUB
	SUB XYLTLN(XN,YE,LAT,LON,PTYP%,JOB%,BUF(1)) STATIC
'
'MAP PROJECTION ROUTINE,ON SPHEROID, RECTANGULAR COORDINATES (X,Y)
'TO GEOGRAPHIC COORDS (LAT,LON)
'GETTINGS,USGS,JUL 1979.
'
'PARAMETERS (ALL REAL*8 EXCEPT PTYP%,JOB%)
'	LAT-LATITUDE IN DEG & DEC.PARTS
'	LON-LONGITUDE IN DEG & DEC.PARTS
'	XN-NORTH COORDINATE,KM.
'	YE-EAST COORDINATE,KM.
'	PTYP%-PROJECTION TYPE (INTEGER)
'	    =1 LAMBERT CONFORMAL CONIC 1 PARALLEL
'	    =2 LAMBERT CONFORMAL CONIC 2 PARALLELS
'	    =3 UNIVERSAL TRANSVERSE MERCATOR
'	JOB%-1 SET UP PARAMETERS & CONSTANTS
'	   -2 TRANSFORM A POINT
'	BUF(1)-BUF(5)- BUFFER CONTAINING PARAMETERS
'		       FOR JOB% = 1.
'
'  SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
'    SECANT, SPHI, SPHIP, TERM, TERMP
'
'
	STATIC PHI0,PHI1,PHI2,LAM0,EC,R0,SP0,C,X,SCF,AEQ
        STATIC A,B,ECS,NS,M1,BUF1
	DGR=.0174532925199433#
	IF(JOB%=2) GO TO LLL300
'
'JOB%=1 - SET UP PARAMETERS
'
	ON PTYP% GOTO LLL10,LLL20,LLL30,LLL40,LLL50
'
'LAMBERT CONF. CONIC 1 PARALLEL
'BUF(1)=EQ. RADIUS SPHEROID,KM.
'BUF(2)=POLAR RAD. SPHEROID,KM.
'BUF(3)=LAT. STANDARD PARALLEL,DEG.
'BUF(4)=LONG. CENTRAL MERIDIAN,DEG.
'
LLL10:	PHI0=BUF(3)*DGR
	LAM0=BUF(4)*DGR
	BUF1=BUF(1):BUF2=BUF(2)
	CALL SUBE(BUF1,BUF2,EC)
	CALL SUBNPHI(BUF1,EC,PHI0,RESULT)
	TNP=TAN(PHI0)
	R0=RESULT/TNP
	SP0=SIN(PHI0)
	CALL SUBTERM(PHI0,EC,SP0,RESULT)
	C=R0/RESULT
	GO TO LLL900
'
'LAMBERT CONFORMAL CONIC 2 PARALLELS
'BUF(1)=EQ. RADIUS SPHEROID
'BUF(2)=POLAR RAD. SPHEROID
'BUF(3)=LAT. STAND. PARALLEL 1,DEG (PAR. FURTHEST FR. EQ.)
'BUF(4)=LAT. STAND. PARALLEL 2,DEG.
'BUF(5)=LON. CENTRAL MERIDIAN,DEG.
'
LLL20:	LAM0=BUF(5)*DGR
	PHI1=BUF(3)*DGR
	PHI2=BUF(4)*DGR
	BUF1=BUF(1): BUF2=BUF(2)
	CALL SUBE(BUF1,BUF2,EC)
	CALL SUBNPHI(BUF1,EC,PHI1,RESULT1)
	CALL SUBNPHI(BUF1,EC,PHI2,RESULT2)
	SP0=LOG(RESULT1*COS(PHI1))-LOG(RESULT2*COS(PHI2))
	CALL SUBTERM(PHI1,EC,1.0D0,RESULT1)
	CALL SUBTERM(PHI2,EC,1.0D0,RESULT2)
	SP0=SP0/(LOG(RESULT1)-LOG(RESULT2))
	PHI0=ATN(SP0/SQR(1.0D0-SP0*SP0))
	CALL SUBNPHI(BUF1,EC,PHI1,RESULT1)
	CALL SUBTERM(PHI1,EC,SP0,RESULT2)
	C=RESULT1*COS(PHI1)/(SP0*RESULT2)
	CALL SUBTERM(PHI0,EC,SP0,RESULT)
	R0=C*RESULT
	GO TO LLL900
'
'UNIVERSAL TRANSVERSE MERCATOR
'BUF(1)=EQ. RADIUS SPHEROID,KM.
'BUF(2)=POLAR RAD. SPHEROID,KM.
'BUF(3)=LON. CENTRAL MERIDIAN,DEG.
'BUF(4)=SCALE FACTOR M0 (USUALLY 0.9996)
'
LLL30:	
	BUF1=BUF(1):BUF2=BUF(2)
	CALL SUBE(BUF1,BUF2,EC)
	TEMP=0.0#
	TEMP%=1
	CALL SUBSPHI(TEMP,BUF1,BUF2,TEMP%,X)
	SCF=BUF(4)
	LAM0=BUF(3)*DGR
	AEQ=BUF(1)
	GO TO LLL900
'
' ALBERS EQUAL AREA
'BUF(1)=EQ. RADIUS SPHEROID
'BUF(2)=POLAR RAD. SPHEROID
'BUF(3)=LAT. STAND. PARALLEL 1,DEG (PAR. FURTHEST FR. EQ.)
'BUF(4)=LAT. STAND. PARALLEL 2,DEG.
'BUF(5)=CENTRAL MERIDIAN, DEG
'
LLL40:	LAM0=BUF(5)*DGR
	PHI1=BUF(3)*DGR
	PHI2=BUF(4)*DGR
 	BUF1=BUF(1): BUF2=BUF(2)
	CALL SUBE(BUF1,BUF2,EC)
	CALL SUBNPHI(BUF1,EC,PHI1,RESULT1):CALL SUBNPHI(BUF(1),EC,PHI2,RESULT2)
	SP0=LOG(RESULT1*COS(PHI1))-LOG(RESULT2*COS(PHI2))
	CALL SUBTERM(PHI1,EC,1.0D0,RESULT1):CALL SUBTERM(PHI2,EC,1.0D0,RESULT2)
	SP0=SP0/(LOG(RESULT1)-LOG(RESULT2))
	PHI0=ATN(SP0/SQR(1.0D0-SP0*SP0))
	A=BUF(1):B=BUF(2):EC=SQR(1.0#-(B/A)^2):ECS=EC*EC
	PHI1=DGR*BUF(3): PHI2=DGR*BUF(4)
	SINPHI=SIN(PHI1):CON=SINPHI:COSPHI=COS(PHI1)
	CALL MSFNZ0(EC,SINPHI,COSPHI,MS1)
	CALL QSFNZ0(EC,SINPHI,COSPHI,QS1)
	SINPHI=SIN(PHI2):COSPHI=COS(PHI2)
	CALL MSFNZ0(EC,SINPHI,COSPHI,MS2)
	CALL QSFNZ0(EC,SINPHI,COSPHI,QS2)
	SINPHI=SIN(PHI0):COSPHI=COS(PHI0)
	CALL QSFNZ0(EC,SINPHI,COSPHI,QS0)
	NS=(MS1*MS1 - MS2*MS2)/(QS2-QS1)
	C=MS1*MS1 + NS*QS1
	R0=A*SQR(C-NS*QS0)/NS
	GOTO LLL900
' MERCATOR
'BUF(1)=EQ. RADIUS SPHEROID
'BUF(2)=POLAR RAD. SPHEROID
'BUF(3)=LATITUDE OF ORIGIN
'BUF(4)=LONGITUDE OF ORIGIN
'
LLL50: 	BUF1=BUF(1): BUF2=BUF(2)
	CALL SUBE(BUF1,BUF2,EC)
	PHI0=DGR*BUF(3)
	LAM0=DGR*BUF(4)
	TEMP=1.0#-EC*SIN(PHI0)^2
	M1=COS(PHI0)/SQR(TEMP)
	GOTO LLL900
'
'JOB%=2 - TRANSFORM X,Y TO LAT,LON
'
LLL300:	ON PTYP% GOTO LLL110,LLL110,LLL120,LLL130,LLL140
'
'LAMBERT CONFORMAL CONIC
'
LLL110:	CPHI=ATN(YE/(R0-XN))
	DL=CPHI/SP0
	R=(R0-XN)*COS(CPHI)+YE*SIN(CPHI)
	F1=R
	F2=EC
	F3=SP0
	F4=C
	X0=0.0
	X1=1.570796327
	XTOL=1E-5
	FTOL=1E-5
	NTOL%=50
	CALL SECANTT(X0,X1,XTOL,FTOL,NTOL%,IFLAG)
	LON=(DL+LAM0)/DGR
	LAT=X1/DGR
	GO TO LLL900
'
'UNIVERSAL TRANSVERSE MERCATOR
'
LLL120:	
	F1=XN/SCF
	X0=0.0
	X1=1.570796327
	XTOL=.00001#
	FTOL=.00001#
	NTOL%=50
	CALL SECANTS(X0,X1,XTOL,FTOL,NTOL%,IFLAG)
	TNP=TAN(X1)
	T1=TNP
	T2=T1*T1
	E2=(EC*EC/(1-EC*EC))*COS(X1)^2
	CALL SUBRPHI(AEQ,EC,X1,R1)
	CALL SUBNPHI(AEQ,EC,X1,N1)
	N2=N1*N1
	R1N1=R1*N1
	TM1=5+3*T2+E2-4*E2*E2-9*E2*T2
	TM2=61+90*T2+46*E2+45*T2*T2-252*T2*E2-3*E2*E2
	TM2=TM2+100*E2^3-66*T2*E2*E2-90*T2*T2*E2
	TM2=TM2+88*E2^4+225*T2^2*E2^2
	TM2=TM2+84*T2*E2^3-192*T2*E2^4
	TM3=1385+T2*(3633+4095*T2+1575*T2*T2)
	Y2=YE*YE/(SCF*SCF)
	DPHI=-Y2/(2*R1N1)+Y2*Y2*TM1/(24*R1N1*N2)
	DPHI=DPHI-Y2^3*TM2/(720*R1N1*N2*N2)+Y2^4*TM3/(40320*R1N1*N2^3)
	DPHI=DPHI*T1
	LAT=(DPHI+X1)/DGR
	YY=YE/(N1*SCF)
	TM1=1+2*T2+E2
	TM2=5+6*E2+28*T2-3*E2*E2+8*T2*E2+24*T2*T2-4*E2^3+4*T2*E2*E2+24*T2*E2^3
	TM3=61+662*T2+1320*T2*T2+720*T2^3
	DLAM=YY-YY^3*TM1/6+YY^5*TM2/120-YY^7*TM3/5040
	DLAM=DLAM/COS(X1)
	LON=(DLAM+LAM0)/DGR
	GOTO LLL900
'
' ALBER EQUAL AREA
'
LLL130:
	X=YE:Y=R0-XN
	RH=SQR(Y*Y + X*X)
	THETA=ATN(X/Y)
	CON=RH*NS/A
	QS=(C - CON*CON)/NS
	IF EC<.0000001# GOTO LLL260
	CON=1.0#-0.5#*(1.0#-ECS)*LOG((1.0#-EC)/(1.0#+EC))/EC
	IF (ABS(CON)-ABS(QS)) > .0000001# GOTO LLL260
	LAT=1.5707963267948#/DGR
	GOTO LLL280
LLL260:	CALL PHI1Z0(EC,QS,LAT)
LLL280: LON=(THETA/NS + LAM0)/DGR
	LAT=LAT/DGR
	GOTO LLL900
LLL140: TEMP=-XN/(BUF1 * M1)
	TS=EXP(TEMP)
	CALL PHI2Z0(EC,TS,RESULT)
	LAT=RESULT/DGR
	LON=(LAM0 + YE / ( BUF1 * M1))/DGR
LLL900:	
END SUB
      SUB SECANTS(X0,X1,XTOL,FTOL,NTOL%,IFLAG) STATIC
'	LOWER BOUND OF RANGE OF X IN WHICH SOLUTION IS SOUGHT
'	UPPER BOUND OF RANGE OF X IN WHICH SOLUTION IS SOUGHT
'	CONTAINS SOLUTION VALUE ON RETURN
'	XTOL	TOLERANCE ON X WITHIN WHICH A SOLUTION IS CONSIDERED TO BE
'		FOUND
'	FTOL	TOLERANCE ON F(X) WITHIN WHICH A SOLUTION IS CONSIDERED TO
'		BE FOUND
'	NTOL%	MAX NUMBER OF ITERATIONS ATTEMPTED
'	IFLAG	0 - SOLUTION IS WITHIN XTOL
'		1 - SOLUTION IS WITHIN FTOL
'		2 - 2 SUCCESSIVE VALUES OF FUNCTION GIVE ZERO DIFFERENCE
'		    OR MAX # ITERATIONS EXCEEDED
'
'  GETTINGS, 1979
'
      IFLAG=0
	CALL SUBSPHIP(X0,FT0)
      DELTAX=X1-X0
      FOR  N%=1 TO NTOL%
		CALL SUBSPHIP(X1,FT1)
	      IF(ABS(FT1)<=FTOL) GO TO LJ30
	      DELTAF=FT0-FT1
	      IF(DELTAF=0.) GO TO LJ999
	      DELTAX=FT1/DELTAF*DELTAX
	      X0=X1
	      X1=X1+DELTAX
	      IF(ABS(DELTAX)<=XTOL) GOTO LJ35
		FT0=FT1
	NEXT N%
LJ999: IFLAG=2:GOTO LJ35
LJ30: IFLAG=1
LJ35:	END SUB
	SUB SUBSPHIP(PHI,RESULT) STATIC
'
'  AUXILIARY SUBROUTINE FOR SUBROUTINE XYLTLN
'  GETTINGS, 1979
'
'    SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
'      SPHI
'
	TEMP%=2
	CALL SUBSPHI(PHI,F2,F3,TEMP%,TEMP)
	RESULT=F1-TEMP
	END SUB
     SUB SUBSPHI(PHI,A,B,JOB%,RESULT) STATIC
'
'COMPUTES MERIDIAN ARC DISTANCE EQUATOR TO LAT. PHI(RADIANS)
'FROM ARMY TECH. MANUAL TM 5-241-18,1960
'GETTINGS, FEB 79.
'JOB%=1-SET UP COEFFS; =2-CALC SPHI
'
      STATIC AP,BP,CP,DP,EP
      IF(JOB%=2) GOTO LL10
      N1=(A-B)/(A+B)
      N2=N1*N1
      N3=N1*N2
      N4=N2*N2
      N5=N4*N1
      AP=A*(1.#-N1+5.#*(N2-N3)/4.#+81.#*(N4-N5)/64.#)
      BP=1.5#*A*(N1-N2+7.#*(N3-N4)/8.#+55.#*N5/64.#)
      CP=15.#*A/16.#*(N2-N3+3.#*(N4-N5)/4.#)
      DP=35.#*A/48.#*(N3-N4+11.#*N5/16.#)
      EP=315.#*A/512.#*(N4-N5)
      RESULT=0.0#
      GOTO LL900
LL10:   RESULT=AP*PHI-BP*SIN(2.#*PHI)+CP*SIN(4.#*PHI)-DP*SIN(6.#*PHI) _
         +EP*SIN(8.#*PHI)
LL900:   END SUB
	SUB SUBRPHI(A,E,PHI,RESULT) STATIC
	RESULT=A*(1-E*E)/((1-E*E*(SIN(PHI))^2)^1.5)
	END SUB
      SUB SECANTT(X0,X1,XTOL,FTOL,NTOL%,IFLAG) STATIC
'	LOWER BOUND OF RANGE OF X IN WHICH SOLUTION IS SOUGHT
'	UPPER BOUND OF RANGE OF X IN WHICH SOLUTION IS SOUGHT
'	CONTAINS SOLUTION VALUE ON RETURN
'	XTOL	TOLERANCE ON X WITHIN WHICH A SOLUTION IS CONSIDERED TO BE
'		FOUND
'	FTOL	TOLERANCE ON F(X) WITHIN WHICH A SOLUTION IS CONSIDERED TO
'		BE FOUND
'	NTOL%	MAX NUMBER OF ITERATIONS ATTEMPTED
'	IFLAG	0 - SOLUTION IS WITHIN XTOL
'		1 - SOLUTION IS WITHIN FTOL
'		2 - 2 SUCCESSIVE VALUES OF FUNCTION GIVE ZERO DIFFERENCE
'		    OR MAX # ITERATIONS EXCEEDED
'
'  GETTINGS, 1979
'
	IFLAG=0
	CALL SUBTERMP(X0,FT0)
	DELTAX=X1-X0
	FOR N%=1 TO NTOL%
		CALL SUBTERMP(X1,FT1)
		IF(ABS(FT1)<=FTOL) GO TO LK30
		DELTAF=FT0-FT1
		IF(DELTAF=0.) GO TO LK999
		DELTAX=FT1/DELTAF*DELTAX
		X0=X1
		X1=X1+DELTAX
		IF(ABS(DELTAX)<=XTOL) GOTO LK35
		FT0=FT1
	NEXT N%
LK999:	IFLAG=2:GOTO LK35
LK30:	IFLAG=1
LK35:	END SUB
	SUB SUBTERMP(PHI,RESULT) STATIC
'
'  AUXILIARY SUBROUTINE FOR SUBROUTINE XYLTLN
'  GETTINGS, 1979
'
'    SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
'    TERM
'
	CALL SUBTERM(PHI,F2,F3,RESULT)
	RESULT=F1-F4*RESULT
	END SUB
SUB QSFNZ0(ECCENT,SINPHI,COSPHI,RESULT) STATIC
 	IF ECCENT <= 0.0000001# THEN RESULT=2.0#*SINPHI _
	ELSE	CON=ECCENT*SINPHI: _
		RESULT=(1.0-ECCENT*ECCENT)*(SINPHI/(1.0#-CON*CON)- _
			(0.5#/ECCENT)*LOG((1.0#-CON)/(1.0#+CON)))
END SUB
SUB MSFNZ0(ECCENT,SINPHI,COSPHI,RESULT) STATIC
 	CON=ECCENT*SINPHI
	RESULT=COSPHI/SQR(1.0#-CON*CON)
END SUB
SUB PHI1Z0(ECCENT,QS,RESULT) STATIC
 	X=0.5# * QS: RESULT=ATN(X/SQR(1.0#-X*X))
	IF ECCENT < .0000001# GOTO END1
	ECCENTS=ECCENT*ECCENT
	PHI=RESULT
	FOR II=1 TO 15
		SINPI=SIN(PHI): COSPI=COS(PI)
		CON=ECCENT*SINPI
		COMTMP=1.0#-CON*CON
		DPHI=0.5#*COMTMP*COMTMP/COSPI*(QS/(1.0#-ECCENTS)- _
			SINPI/COMTMP +0.5#/ECCENT*LOG((1.0#-CON)/(1.0#+CON)))
		PHI=PHI+DPHI
		IF ABS(DPHI)<=.0000001# THEN RESULT=PHI:GOTO END1
	NEXT II
	PRINT "FAILED TO CONVERGE AFTER 20 ITERATIONS"
END1:
END SUB
SUB TSFNZ0(ECCENT,PHI,SINPHI,RESULT) STATIC
 	CON=ECCENT*SINPHI
	CEM=0.5#*ECCENT
	CON=((1.0#-CON)/(1.0#+CON)) ^ CEM
	RESULT= TAN(0.5# * (1.5707963267948966#-PHI)) / CON
END SUB
SUB PHI2Z0(ECCENT,TS,RESULT) STATIC
 	ECCNTH=0.5#*ECCENT
	PHI=1.5707963267948966# - 2.0#*ATN(TS)
	FOR I = 1 TO 20
		SINPI = SIN(PHI)
		CON = ECCENT * SINPI
		DPHI = 1.5707963267948966# - 2.0# * ATN(TS * ((1.0#-CON)/(1.0#+CON))^ECCNTH) - PHI
		PHI=PHI+DPHI
		IF ABS(DPHI)<=1.0D-10 THEN RESULT=PHI:GOTO END2
	NEXT I
	PRINT "FAILED TO CONVERGE AFTER 20 ITERATIONS"
END2:
END SUB
